package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameEventGroupBo;
import org.dromara.system.domain.vo.GameEventGroupVo;
import org.dromara.system.domain.GameEventGroup;
import org.dromara.system.mapper.GameEventGroupMapper;
import org.dromara.system.service.IGameEventGroupService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 赛事分组Service业务层处理
 *
 * @author zlt
 * @date 2025-07-30
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameEventGroupServiceImpl implements IGameEventGroupService {

    private final GameEventGroupMapper baseMapper;

    /**
     * 查询赛事分组
     *
     * @param groupId 主键
     * @return 赛事分组
     */
    @Override
    public GameEventGroupVo queryById(Long groupId){
        return baseMapper.selectVoById(groupId);
    }

    /**
     * 分页查询赛事分组列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 赛事分组分页列表
     */
    @Override
    public TableDataInfo<GameEventGroupVo> queryPageList(GameEventGroupBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameEventGroup> lqw = buildQueryWrapper(bo);
        Page<GameEventGroupVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的赛事分组列表
     *
     * @param bo 查询条件
     * @return 赛事分组列表
     */
    @Override
    public List<GameEventGroupVo> queryList(GameEventGroupBo bo) {
        LambdaQueryWrapper<GameEventGroup> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameEventGroup> buildQueryWrapper(GameEventGroupBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameEventGroup> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameEventGroup::getGroupId);
        lqw.eq(bo.getEventId() != null, GameEventGroup::getEventId, bo.getEventId());
        lqw.like(StringUtils.isNotBlank(bo.getGroupName()), GameEventGroup::getGroupName, bo.getGroupName());
        lqw.eq(StringUtils.isNotBlank(bo.getProjectList()), GameEventGroup::getProjectList, bo.getProjectList());
        lqw.eq(StringUtils.isNotBlank(bo.getMemberGender()), GameEventGroup::getMemberGender, bo.getMemberGender());
        lqw.eq(StringUtils.isNotBlank(bo.getSortOrder()), GameEventGroup::getSortOrder, bo.getSortOrder());
        lqw.eq(bo.getSortRule() != null, GameEventGroup::getSortRule, bo.getSortRule());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), GameEventGroup::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增赛事分组
     *
     * @param bo 赛事分组
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameEventGroupBo bo) {
        GameEventGroup add = MapstructUtils.convert(bo, GameEventGroup.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setGroupId(add.getGroupId());
        }
        return flag;
    }

    /**
     * 修改赛事分组
     *
     * @param bo 赛事分组
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameEventGroupBo bo) {
        GameEventGroup update = MapstructUtils.convert(bo, GameEventGroup.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameEventGroup entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除赛事分组信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
